uniform sampler2D texCanvas;
//uniform sampler2D texScaledCanvas;

uniform vec2 filterTaps[12];
uniform vec2 pixelSize;
//uniform vec2 pixelSizeScaled;

uniform vec2 maxCoC;
//uniform float radiusScale;


void main()
{
	float centerDepth = texture2D(texCanvas, gl_TexCoord[0].st).a;
	
	float discRadius = abs(centerDepth * maxCoC.y - maxCoC.x);
	//float discRadiusScaled = discRadius * radiusScale;
	
	vec4 finalColor = vec4(0);
	for (int i=0; i<8; i++) {
	
		// compute texture coordinates
		//vec2 texCoordScaled = gl_TexCoord[0].st + pixelSizeScaled * filterTaps[i] * discRadiusScaled;
		vec2 texCoord = gl_TexCoord[0].st + pixelSize * filterTaps[i] * discRadius;
				
		// get the texels
		vec4 finalTap = texture2D(texCanvas, texCoord);
		//vec4 tap = texture2D(texCanvas, texCoord);
		//vec4 tapScaled = texture2D(texScaledCanvas, texCoordScaled);
		
		// mix the two colors
		//float tapBlur = abs(tap.a * 2.0 - 1.0); // put in [0-1] range
		//vec4 finalTap = mix(tap, tapScaled, tapBlur);
		
		// avoid leaking of color, sharp objects behind blurred background would have a halo
		finalTap.a = (finalTap.a >= centerDepth) ? 1.0 : abs(finalTap.a * 2.0 - 1.0);
				
		finalColor.rgb += (finalTap.rgb * finalTap.a);
		finalColor.a += finalTap.a;
	}
	gl_FragColor = (finalColor / finalColor.a);
	
	//gl_FragColor.rgb = vec3(centerDepth);
}