uniform sampler2D texCanvas;
uniform sampler2D texPosition;
uniform vec3 dofPlanes; // x:= near; y:= focus; z:= far

void main ()
{
	float depth = -texture2D(texPosition, gl_TexCoord[0].st).z;
	
	// set the background to to highest blur factor
	//if (depth == 0.0) 
	//	depth = dofPlanes.z; 
	
	// compute the blur factor
	float f;
	if (depth < dofPlanes.y) { // [-1,0]
		f = (depth - dofPlanes.y) / (dofPlanes.y - dofPlanes.x);
		//f = clamp(f, -1.0, 0.0);	
	}
	else { // [0,1]
		f = (depth - dofPlanes.y) / (dofPlanes.z - dofPlanes.y);
		f = clamp(f, 0.0, 1.0);
	}
	
	gl_FragColor.a = f * 0.5 + 0.5;
	gl_FragColor.rgb = texture2D(texCanvas, gl_TexCoord[0].st).rgb;
}